<?php

load_plugin_textdomain('capa', $path='wp-content/plugins/capa');

if (!class_exists("capa_protect_user_edit")) {

class capa_protect_user_edit {

	function update() {
		if (strpos($_SERVER['REQUEST_URI'], '/wp-admin/user-edit.php') === false || $_POST['action'] != 'update')
			return NULL;

		$user_id = empty($_POST['user_id']) ? $_GET['user_id'] : $_POST['user_id'];

		if($_POST['capa_protect_user_reset'] == 'on'){
			delete_option("capa_protect_cat_user_${user_id}");
			delete_option("capa_protect_pag_user_${user_id}");
			return NULL;
		}

		$tmp['capa_protect_cat'] = NULL;
		$tmp['capa_protect_pag'] = NULL;

			if(is_array($tmp['capa_protect_cat'])){
				foreach($_POST['capa_protect_cat'] as $id=>$value){
					$tmp['capa_protect_cat'][$id] = TRUE;
				}
					capa_protect::set_access_for_user($user_id, $tmp['capa_protect_cat'],'cat');
			}else{
				delete_option("capa_protect_cat_user_${user_id}");
			}
	
			if(is_array($tmp['capa_protect_pag'])){
				foreach($_POST['capa_protect_pag'] as $id=>$value){
					$tmp['capa_protect_pag'][$id] = TRUE;
				}
					capa_protect::set_access_for_user($user_id, $tmp['capa_protect_pag'],'pag');
			}else{
				delete_option("capa_protect_pag_user_${user_id}");
			}
	}

	function print_html() {

		echo '<br>';

		echo '<h2>'. __('CaPa User Settings','capa').'</h2><br>';

		$user_id = empty($_POST['user_id']) ? $_GET['user_id'] : $_POST['user_id'];
		$user = new WP_User($user_id);

		if ($user->has_cap('manage_categories') && !$user->caps['editor']) {

			echo '<h3>'. __('Access','capa') .' &amp; </h3>';

			echo '<p class="desc">'. __('As a manager, this user can view all categories & pages.','capa').'</p>';

		}else{

			echo '<div style="float:left;">';
				echo '<h3>'. __('Category Access','capa').'</h3>';

				echo '<p class="desc">'. __('The following checked categories are visible to this user.','capa').'</p>';

				$category_ids = get_all_category_ids();
				$category_check = get_option("capa_protect_cat_user_${user_id}");

				function sort_category_ids_by_name($id1,$id2) {
				  return strcmp(strtolower(get_catname($id1)),
					strtolower(get_catname($id2)));
				}
				usort($category_ids, 'sort_category_ids_by_name');

				echo '<table cellpadding="3" cellspacing="3">';

				foreach ($category_ids as $category_id) {
					echo '<tr>';
					echo '<td>';

					echo '<input type="checkbox" name="capa_protect_cat['.$category_id.']" '. (($category_check[$category_id] === TRUE) ? ' checked ' : NULL). '> '. get_catname($category_id);

					echo '</td>';
					echo '</tr>';
				}

				echo '</table>';
			echo '</div>';

			echo '<div style="float:right;">';
				echo '<h3>'. __('Page Access','capa').'</h3>';

				echo '<p class="desc">'. __('The following checked pages are visible to this user.','capa') .'</p>';

				$page_ids = & get_pages($args);
				$page_check = get_option("capa_protect_pag_user_${user_id}");

				#usort($category_ids, 'sort_category_ids_by_name');

				echo '<table cellpadding="3" cellspacing="3">';

				foreach ($page_ids as $page_id) {
					echo '<tr>';
					echo '<td>';

					echo '<input type="checkbox" name="capa_protect_pag['.$page_id->ID.']" '. (($page_check[$page_id->ID] === TRUE) ? ' checked ' : NULL). '> ' .$page_id->post_title;

					echo '</td>';
					echo '</tr>';
				}

				echo '</table>';
			echo '</div>';

		}

		echo '<div style="clear:both;">';
		echo '<br><hr><br>';
		echo '<input type="checkbox" name="capa_protect_user_reset"> '. __('Reset current CaPa user settings','capa');

	}

}

}

// --------------------------------------------------------------------

// We'll use a very low priority so that our plugin will run after everyone
// else's. That way we won't interfere with other plugins.
// ADD SM: Sound Good ^_^

add_action('edit_user_profile',
	array('capa_protect_user_edit','print_html'));

add_action('init',
	array('capa_protect_user_edit','update'));

?>
